#include <tos.h>
#include <aes.h>
#include <vdi.h>
#include <stdint.h>
#include "monaco10.h"

static GRECT desk;
static _WORD phys_handle;
static _WORD vdi_handle;
static _WORD workout[57];
static _WORD dummy;

static void openvwk(void)
{
	int i;
	_WORD workin[11];

	for (i = 0; i < 10; i++)
		workin[i] = 1;
	workin[10] = 2;
	vdi_handle = phys_handle;
	v_opnvwk(workin, &vdi_handle, workout);
}


static void clrscr(void)
{
	_WORD pxy[8];

	grect_to_array(&desk, pxy);
	vswr_mode(vdi_handle, MD_REPLACE);
	vsf_color(vdi_handle, G_WHITE);
	vsf_interior(vdi_handle, FIS_SOLID);
	vsf_perimeter(vdi_handle, 0);
	vr_recfl(vdi_handle, pxy);
}


static void printstr(const FONT_HDR *font, _WORD x, _WORD y, const char *str)
{
	_WORD colors[2];
	_WORD pxy[8];
	MFDB src, dst;
	const UWORD *off_table;
	
	colors[0] = G_BLUE;
	colors[1] = G_WHITE;
	off_table = font->off_table;

	memset(&dst, 0, sizeof(dst));
	src.fd_addr = (void *)font->dat_table;
	src.fd_w = font->form_width << 3;
	src.fd_h = font->form_height;
	src.fd_wdwidth = font->form_width >> 1;
	src.fd_stand = 0;
	src.fd_nplanes = 1;

	while (*str)
	{
		UWORD c = (unsigned char)*str++;
		UWORD w;
		
		if (c < font->first_ade || c > font->last_ade)
			continue;
		c -= font->first_ade;
		w = off_table[c + 1] - off_table[c];

		pxy[0] = off_table[c];
		pxy[1] = 0;
		pxy[2] = pxy[0] + w - 1;
		pxy[3] = font->form_height - 1;
		pxy[4] = x;
		pxy[5] = y;
		pxy[6] = x + w - 1;
		pxy[7] = y + font->form_height - 1;
		vrt_cpyfm(vdi_handle, MD_TRANS, pxy, &src, &dst, colors);
		x += w;
	}
}


int main(void)
{
	appl_init();
	
	wind_get_grect(0, WF_WORKXYWH, &desk);
	phys_handle = graf_handle(&dummy, &dummy, &dummy, &dummy);
	openvwk();
	graf_mouse(ARROW, 0);

	wind_update(BEG_UPDATE);
	wind_update(BEG_MCTRL);
	form_dial_grect(FMD_START, &desk, &desk);

	v_hide_c(vdi_handle);
	clrscr();
	printstr(&THISFONT, 100, 100, "Hello, world");
	printstr(&THISFONT, 100, 150, "(press any key)");
	
	v_show_c(vdi_handle, 0);
	evnt_keybd();
	
	form_dial_grect(FMD_FINISH, &desk, &desk);
	wind_update(END_MCTRL);
	wind_update(END_UPDATE);
	v_clsvwk(vdi_handle);
	
	appl_exit();
	return 0;
}
